# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.any_of_validation_error_loc_items import AnyOfValidationErrorLocItems  # noqa: F401,E501
from swagger_server import util


class ValidationError(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, loc: List[AnyOfValidationErrorLocItems]=None, msg: str=None, type: str=None):  # noqa: E501
        """ValidationError - a model defined in Swagger

        :param loc: The loc of this ValidationError.  # noqa: E501
        :type loc: List[AnyOfValidationErrorLocItems]
        :param msg: The msg of this ValidationError.  # noqa: E501
        :type msg: str
        :param type: The type of this ValidationError.  # noqa: E501
        :type type: str
        """
        self.swagger_types = {
            'loc': List[AnyOfValidationErrorLocItems],
            'msg': str,
            'type': str
        }

        self.attribute_map = {
            'loc': 'loc',
            'msg': 'msg',
            'type': 'type'
        }
        self._loc = loc
        self._msg = msg
        self._type = type

    @classmethod
    def from_dict(cls, dikt) -> 'ValidationError':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ValidationError of this ValidationError.  # noqa: E501
        :rtype: ValidationError
        """
        return util.deserialize_model(dikt, cls)

    @property
    def loc(self) -> List[AnyOfValidationErrorLocItems]:
        """Gets the loc of this ValidationError.


        :return: The loc of this ValidationError.
        :rtype: List[AnyOfValidationErrorLocItems]
        """
        return self._loc

    @loc.setter
    def loc(self, loc: List[AnyOfValidationErrorLocItems]):
        """Sets the loc of this ValidationError.


        :param loc: The loc of this ValidationError.
        :type loc: List[AnyOfValidationErrorLocItems]
        """
        if loc is None:
            raise ValueError("Invalid value for `loc`, must not be `None`")  # noqa: E501

        self._loc = loc

    @property
    def msg(self) -> str:
        """Gets the msg of this ValidationError.


        :return: The msg of this ValidationError.
        :rtype: str
        """
        return self._msg

    @msg.setter
    def msg(self, msg: str):
        """Sets the msg of this ValidationError.


        :param msg: The msg of this ValidationError.
        :type msg: str
        """
        if msg is None:
            raise ValueError("Invalid value for `msg`, must not be `None`")  # noqa: E501

        self._msg = msg

    @property
    def type(self) -> str:
        """Gets the type of this ValidationError.


        :return: The type of this ValidationError.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str):
        """Sets the type of this ValidationError.


        :param type: The type of this ValidationError.
        :type type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type
